//
//  HereMapView.swift
//  iOS Navigate Reference App
//
//  Created by Jonda, Sachin on 10.05.22.
//  Copyright © 2023 HERE Technologies. All rights reserved.
//

import SwiftUI
import heresdk

/// Holds MapView weakly.
class MapViewHolder {
    weak var mapView: MapView?
}

struct HereMapView: UIViewRepresentable {

    var mapViewHolder = MapViewHolder()

    func makeUIView(context: Context) -> MapView {
        print("HereMapView component: make UI view called...")

        // For debug purposed, print currently used Key ID
        print("Using credentails: ID--> \(String(describing: SDKNativeEngine.sharedInstance?.options.accessKeyId))")

        let mapView = MapView(frame: .zero, options: MapViewOptions(projection: MapProjection.globe))
        self.mapViewHolder.mapView = mapView

        return mapView
    }

    func updateUIView(_ mapView: MapView, context: Context) {
        //print("HereMapView component: update UI view called...")
    }

}

struct HereMapView_Previews: PreviewProvider {
    static var previews: some View {
        HereMapView()
    }
}
